From 8d53c68ac32f1f74159bef1f53f4796e46d98746 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Juho=20V=C3=A4h=C3=A4-Herttua?= <juhovh@iki.fi>
Date: Sun, 25 Jul 2010 01:52:28 +0300
Subject: [PATCH] qt4: Run mainloop on the main thread on OSX

---
 modules/gui/qt4/qt4.cpp |   21 ++++++++++++++++++---
 1 files changed, 18 insertions(+), 3 deletions(-)

diff --git a/modules/gui/qt4/qt4.cpp b/modules/gui/qt4/qt4.cpp
index 676a82b..eea03cb 100644
--- a/modules/gui/qt4/qt4.cpp
+++ b/modules/gui/qt4/qt4.cpp
@@ -324,6 +324,12 @@ static int Open( vlc_object_t *p_this, bool isDialogProvider )
     x11_display = display;
 #endif
     vlc_sem_init (&ready, 0);
+#ifdef Q_WS_MAC
+    /* Run mainloop thread on first thread instead */
+    p_intf->b_should_run_on_first_thread = true;
+    p_intf->pf_run = (void(*)(intf_thread_t *))Thread;
+    vlc_sem_post (&ready);
+#else
     if( vlc_clone( &p_sys->thread, Thread, p_intf, VLC_THREAD_PRIORITY_LOW ) )
     {
         delete p_sys;
@@ -333,10 +339,10 @@ static int Open( vlc_object_t *p_this, bool isDialogProvider )
         vlc_mutex_unlock (&one.lock);
         return VLC_ENOMEM;
     }
+#endif
 
-    /* */
+    /* Wait until the interface is initialized */
     vlc_sem_wait (&ready);
-    vlc_sem_destroy (&ready);
 
     if( !p_sys->b_isDialogProvider )
     {
@@ -374,7 +380,13 @@ static void Close( vlc_object_t *p_this )
 
     QVLCApp::triggerQuit();
 
+#ifdef Q_WS_MAC
+    vlc_sem_wait (&ready);
+    vlc_sem_wait (&ready);
+#else
     vlc_join (p_sys->thread, NULL);
+#endif
+    vlc_sem_destroy (&ready);
 #ifdef Q_WS_X11
     free (x11_display);
     x11_display = NULL;
@@ -458,7 +470,7 @@ static void *Thread( void *obj )
     /* Explain how to show a dialog :D */
     p_intf->pf_show_dialog = ShowDialog;
 
-    /* */
+    /* Notify that the interface is initialized */
     vlc_sem_post (&ready);
 
     /* Last settings */
@@ -510,6 +522,9 @@ static void *Thread( void *obj )
     /* Destroy the MainInputManager */
     MainInputManager::killInstance();
 
+    /* Notify that the interface is cleaned up */
+    vlc_sem_post (&ready);
+
     /* Delete the application automatically */
     return NULL;
 }
-- 
1.6.5.7

